package in.takesit.statsreporter;

import java.io.File;

import org.apache.catalina.LifecycleException;
import org.apache.catalina.startup.Tomcat;

public class ServerThread extends Thread {
	private LogInterface logInt = LogInterface.getInstance();
	private static int httpPort = 8069;
	private static int httpsPort = 8070;
	private static boolean httpOn = true;
	private static boolean httpsOn = false;
	private static String webContentDir = "/usr/local/share/statsreporter/web/";
	
	public ServerThread() {
		
	}

	public ServerThread(Runnable target) {
		super(target);
	}

	public ServerThread(String name) {
		super(name);
	}

	public ServerThread(ThreadGroup group, Runnable target) {
		super(group, target);
	}

	public ServerThread(ThreadGroup group, String name) {
		super(group, name);
	}

	public ServerThread(Runnable target, String name) {
		super(target, name);
	}

	public ServerThread(ThreadGroup group, Runnable target, String name) {
		super(group, target, name);
	}

	public ServerThread(ThreadGroup group, Runnable target, String name,
			long stackSize) {
		super(group, target, name, stackSize);
	}

	public void run() {
		Tomcat tomcatServer = new Tomcat();
		File docBase = new File(ServerThread.getWebContentDir());
		tomcatServer.addWebapp(null, "", docBase.getAbsolutePath());
		
		if (ServerThread.isHttpOn()) {
			tomcatServer.setPort(ServerThread.getHttpPort());
		}
		
		if (ServerThread.isHttpsOn()) {
			
		}
	
		try {
			tomcatServer.start();
		} catch (LifecycleException e) {
			logInt.logError(e.getMessage());
		}		

	}

	public static int getHttpPort() {
		return httpPort;
	}

	public static void setHttpPort(int httpPort) {
		ServerThread.httpPort = httpPort;
	}

	public static int getHttpsPort() {
		return httpsPort;
	}

	public static void setHttpsPort(int httpsPort) {
		ServerThread.httpsPort = httpsPort;
	}

	public static boolean isHttpOn() {
		return httpOn;
	}

	public static void setHttpOn(boolean httpOn) {
		ServerThread.httpOn = httpOn;
	}

	public static boolean isHttpsOn() {
		return httpsOn;
	}

	public static void setHttpsOn(boolean httpsOn) {
		ServerThread.httpsOn = httpsOn;
	}

	public static String getWebContentDir() {
		return webContentDir;
	}

	public static void setWebContentDir(String webContentDir) {
		ServerThread.webContentDir = webContentDir;
	}
	
}
