package in.takesit.statsreporter.data;

import java.io.IOException;
import java.io.InputStream;
import java.util.Calendar;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.util.EntityUtils;

import com.google.gson.Gson;


public class HttpStatsGrabber extends Thread {

	private long interval = 60000;
	private String url = "http://target.fapddos.com/http-stats.php";


	public HttpStatsGrabber() {
		// TODO Auto-generated constructor stub
	}

	public HttpStatsGrabber(Runnable target) {
		super(target);
		// TODO Auto-generated constructor stub
	}

	public HttpStatsGrabber(String name) {
		super(name);
		// TODO Auto-generated constructor stub
	}

	public HttpStatsGrabber(ThreadGroup group, Runnable target) {
		super(group, target);
		// TODO Auto-generated constructor stub
	}

	public HttpStatsGrabber(ThreadGroup group, String name) {
		super(group, name);
		// TODO Auto-generated constructor stub
	}

	public HttpStatsGrabber(Runnable target, String name) {
		super(target, name);
		// TODO Auto-generated constructor stub
	}

	public HttpStatsGrabber(ThreadGroup group, Runnable target, String name) {
		super(group, target, name);
		// TODO Auto-generated constructor stub
	}

	public HttpStatsGrabber(ThreadGroup group, Runnable target, String name,
			long stackSize) {
		super(group, target, name, stackSize);
		// TODO Auto-generated constructor stub
	}

	public void run () {
		StatsStore stats = StatsStore.getInstance();
		boolean collect = true;
		long initWait = Calendar.getInstance().getTimeInMillis() % this.interval;
		try {
			Thread.sleep(initWait);
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		Gson gson = new Gson();
		while (collect) {
			try {
				HttpClient httpclient = new DefaultHttpClient();
				HttpGet httpget = new HttpGet(this.url);
				HttpResponse response = httpclient.execute(httpget);
				HttpEntity entity = response.getEntity();
				if (entity != null) {
				    long len = entity.getContentLength();
				    if (len != -1 && len < 2048) {
				    	String jsonRes = EntityUtils.toString(entity);
				        System.out.println(jsonRes);
				        HttpStatsGrab grab = gson.fromJson(jsonRes, HttpStatsGrab.class);
				        stats.add(url+"_BusyWorkers", grab.getBusyWorkers());
				        stats.add(url+"_BytesPerReq", grab.getBytesPerReq());
				        stats.add(url+"_BytesPerSec", grab.getBytesPerSec());
				        stats.add(url+"_CPULoad", grab.getCPULoad());
				        stats.add(url+"_IdleWorkers", grab.getIdleWorkers());
				        stats.add(url+"_RequestsPerSecond", grab.getReqPerSec());
				        stats.add(url+"_TotalAccesses", grab.getTotalAccesses());
				        stats.add(url+"_totalKBytes", grab.getTotalkBytes());
				        stats.add(url+"_uptime", grab.getUptime());
				        
				        
				    } else {
				        // Stream content out
				    }
				}
			} catch (ClientProtocolException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} finally {

			}

			try {
				Thread.sleep(Calendar.getInstance().getTimeInMillis() % this.interval);
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}


	}

	public long getInterval() {
		return interval;
	}

	public void setInterval(long interval) {
		this.interval = interval;
	}

	public String getUrl() {
		return url;
	}

	public void setUrl(String url) {
		this.url = url;
	}
}
