package in.takesit.statsreporter.data;

import java.util.Calendar;
import java.util.Hashtable;

public class StatsStore {
	private static StatsStore instance = null;
	private Hashtable<String,Double[]> statsStore = new  Hashtable<String,Double[]>();
	private int storeSize = 60*24; //1 minute interval for 24 hours
	
	
	public int getStoreSize() {
		return storeSize;
	}

	public void setStoreSize(int storeSize) {
		this.storeSize = storeSize;
		this.setFullCycle();
	}

	private long interval = 60*1000;
	private long fullCycle = storeSize * interval;
	
	protected StatsStore() {
	}

	public static StatsStore getInstance() {
		if(instance == null) {
			instance = new StatsStore();
		}
		return instance;
	}
	
	private int getMark() {
		int retVal = 0;
		retVal = (int) (Math.floor((Calendar.getInstance().getTimeInMillis() % this.fullCycle))/1000/60);
		return retVal;
	}
	
	public void add(String key , Double value) {
		int curIndex = this.getMark();
		if (!this.statsStore.containsKey(key)) {
			//Ok, init a data strucutre, popultate it with the first set of data
			Double[] newStats = new Double[this.storeSize];
			for (int x = 0; x < this.storeSize;x++) {
				newStats[x] =new Double(0);
			}
			this.statsStore.put(key, newStats);
		}
		this.statsStore.get(key)[curIndex] = value;
		System.out.println(curIndex);
	}

	public long getInterval() {
		return interval;
	}

	public void setInterval(long interval) {
		this.interval = interval;
		this.setFullCycle();
	}

	public long getFullCycle() {
		return fullCycle;
	}

	private void setFullCycle() {
		this.fullCycle = this.interval * this.storeSize;
	}
}
